## quassel 0.12.4

=== CMakeLists.txt ===
# Main CMake file for building Quassel IRC
#
# See INSTALL for possible CMake options (or read the code, Luke)
#####################################################################

# General setup
#####################################################################

project(QuasselIRC)

# Versions
set(QUASSEL_MAJOR  0)
set(QUASSEL_MINOR 12)
set(QUASSEL_PATCH  4)
set(QUASSEL_VERSION_STRING "0.12.4")

# We want to know CMake's version for debug reasons
message(STATUS "Using CMake ${CMAKE_VERSION}")

# Tell CMake about or own modules
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

# General conveniences
set(CMAKE_AUTOMOC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)

# Include various CMake modules...
include(CMakePushCheckState)
include(CheckFunctionExists)
include(CheckIncludeFile)
include(CheckCXXSourceCompiles)
include(CMakeDependentOption)
include(FeatureSummary)

# ... and our own stuff
include(QuasselCompileSettings)
include(QuasselMacros)


# Options and variables that can be set on the command line
#####################################################################

# First, choose a Qt version. We support USE_QT4 and USE_QT5; if neither is set, prefer Qt4 for now
option(USE_QT5 "Enable support for Qt5 (disables KDE integration)" OFF)
if (USE_QT4) # takes precedence
    set(USE_QT5 OFF)
else()
    if (NOT USE_QT5)
        set(USE_QT4 ON)
    endif()
endif()

# Select the binaries to build
option(WANT_CORE     "Build the core (server) binary"           ON)
option(WANT_QTCLIENT "Build the client-only binary"             ON)
option(WANT_MONO     "Build the monolithic (all-in-one) binary" ON)
add_feature_info(WANT_CORE WANT_CORE "Build the core (server) binary")
add_feature_info(WANT_QTCLIENT WANT_QTCLIENT "Build the client-only binary (requires a core to connect to)")
add_feature_info(WANT_MONO WANT_MONO "Build the monolithic (all-in-one) binary")

# Whether to enable KDE integration (work in progress for Qt5 / KDE Frameworks)
# Note that when building with Qt5, WITH_KDE enables integration with higher-tier KDE frameworks that
# require runtime support. We still optionally make use of certain Tier 1 frameworks even if WITH_KDE
# is disabled.
if (USE_QT4)
    option(WITH_KDE "KDE4 integration" OFF)
    add_feature_info(WITH_KDE WITH_KDE "Enable KDE4 integration")
else()
    option(WITH_KDE "Integration with the KDE Frameworks runtime environment")
    add_feature_info(WITH_KDE WITH_KDE "Integrate with the KDE Frameworks runtime environment")
endif()

cmake_dependent_option(WITH_OXYGEN "Install Oxygen icon set (usually shipped with KDE)" ON "NOT WITH_KDE" OFF)
if (NOT WITH_KDE)
    add_feature_info(WITH_OXYGEN WITH_OXYGEN "Install Oxygen icon set")
endif()

# For this, the feature info is added after we know if QtWebkit is installed
option(WITH_WEBKIT "WebKit support (for link previews)" ON)

if (APPLE)
    # Notification Center is only available in > 10.8, which is Darwin v12
    if (CMAKE_SYSTEM_VERSION VERSION_GREATER "11.9.9")
        option(WITH_NOTIFICATION_CENTER "OS X Notification Center support" ON)
        add_feature_info(WITH_NOTIFICATION_CENTER WITH_NOTIFICATION_CENTER "Use the OS X Notification Center")
    endif()
endif()

# Always embed on Windows, OSX or for a static build; never embed when enabling KDE integration
set(EMBED_DEFAULT OFF)
if (STATIC OR WIN32 OR APPLE)
    set(EMBED_DEFAULT ON)
endif()
cmake_dependent_option(EMBED_DATA "Embed icons and translations into the binaries instead of installing them" ${EMBED_DEFAULT}
                                   "NOT STATIC;NOT WIN32;NOT WITH_KDE" ${EMBED_DEFAULT})
if (NOT EMBED_DEFAULT)
    add_feature_info(EMBED_DATA EMBED_DATA "Embed icons and translations in the binaries instead of installing them")
endif()

# The following options are not for end-user consumption, so don't list them in the feature summary
cmake_dependent_option(DEPLOY "Add required libs to bundle resources and create a dmg. Note: requires Qt to be built with 10.4u SDK" OFF "APPLE" OFF)

# Handle with care
set(QT_PATH "" CACHE PATH "Path to a Qt4 installation to use instead of the system Qt (e.g. for static builds)")

# Static builds are not supported and require some manual setup! Don't enable unless you know what you're doing (we don't know either)
cmake_dependent_option(STATIC      "Enable static building (not supported)" OFF "NOT WITH_KDE" OFF)

# For static builds, arbitrary extra libs might need to be linked
# Define a comma-separated list here
# e.g. for pgsql, we need -DLINK_EXTRA=pq;crypt
set(LINK_EXTRA "" CACHE STRING "Semicolon-separated list of libraries to be linked")
if (LINK_EXTRA)
    string(REPLACE "," ";" LINK_EXTRA ${LINK_EXTRA})
    link_libraries(${LINK_EXTRA})
endif()


# Setup CMake
#####################################################################

if (USE_QT5 AND WITH_KDE)
    cmake_minimum_required(VERSION 2.8.12)
else()
    cmake_minimum_required(VERSION 2.8.9)
endif()

# Setting COMPILE_DEFINITIONS_<CONFIG> is deprecated since CMake 3.0 in favor of generator expressions.
# These have existed since CMake 2.8.10; until we depend on that, we have to explicitly enable the old policy.
if (CMAKE_MAJOR_VERSION GREATER 2)
    cmake_policy(SET CMP0043 OLD)
endif()


# Simplify later checks
#####################################################################

if (WANT_MONO OR WANT_QTCLIENT)
    set(BUILD_GUI true)
endif()
if (WANT_MONO OR WANT_CORE)
    set(BUILD_CORE true)
endif()


# Set up Qt
#####################################################################

if (USE_QT5)
    message(STATUS "Building for Qt5...")
    set(QT_MIN_VERSION "5.2.0")
    add_definitions(-DHAVE_QT5)
else()
    message(STATUS "Building for Qt4...")
    set(QT_MIN_VERSION "4.8.0")

    # Select a Qt installation here, if you don't want to use system Qt
    if(QT_PATH)
        # FindQt4 will look for the qmake binary in $PATH, so we just prepend QT_PATH
        set(ENV{PATH} ${QT_PATH}/bin:$ENV{PATH})
    endif()
endif()


# Find package dependencies
#
# Note that you can forcefully disable optional packages
# using -DCMAKE_DISABLE_FIND_PACKAGE_<PkgName>=TRUE
#####################################################################

if (USE_QT5)
    find_package(Qt5Core ${QT_MIN_VERSION} QUIET)
    set_package_properties(Qt5Core PROPERTIES TYPE REQUIRED
        URL "http://qt.digia.com"
        DESCRIPTION "contains core functionality for Qt"
    )
    # find_package without REQUIRED won't check for the version properly; also, older Qt5 versions
    # used Qt5Core_VERSION_STRING... let's just make sure here that we bail out here if our Qt5 is not new enough.
    if (NOT Qt5Core_VERSION OR Qt5Core_VERSION VERSION_LESS ${QT_MIN_VERSION})
        message(FATAL_ERROR "Could NOT find Qt5 >= version ${QT_MIN_VERSION}!")
    endif()

    find_package(Qt5Network QUIET)
    set_package_properties(Qt5Network PROPERTIES TYPE REQUIRED
        DESCRIPTION "the network module for Qt5"
    )

    if (BUILD_GUI)
        find_package(Qt5Gui QUIET)
        set_package_properties(Qt5Gui PROPERTIES TYPE REQUIRED
            DESCRIPTION "the GUI module for Qt5"
        )
        find_package(Qt5Widgets QUIET)
        set_package_properties(Qt5Widgets PROPERTIES TYPE REQUIRED
            DESCRIPTION "the widgets module for Qt5"
        )

        find_package(Qt5DBus QUIET)
        set_package_properties(Qt5DBus PROPERTIES TYPE RECOMMENDED
            URL "http://qt.digia.com"
            DESCRIPTION "D-Bus support for Qt5"
            PURPOSE     "Needed for supporting D-Bus-based notifications and tray icon, used by most modern desktop environments"
        )
        if (Qt5DBus_FOUND)
            find_package(dbusmenu-qt5 QUIET CONFIG)
            set_package_properties(dbusmenu-qt5 PROPERTIES TYPE RECOMMENDED
                URL "https://launchpad.net/libdbusmenu-qt"
                DESCRIPTION "a library implementing the DBusMenu specification"
                PURPOSE     "Required for having a context menu for the D-Bus-based tray icon"
            )
        endif()

        find_package(Phonon4Qt5 QUIET)
        set_package_properties(Phonon4Qt5 PROPERTIES TYPE RECOMMENDED
            URL "https://projects.kde.org/projects/kdesupport/phonon"
            DESCRIPTION "a multimedia abstraction library"
            PURPOSE     "Required for audio notifications"
        )

        find_package(LibsnoreQt5 0.7.0 QUIET)
        set_package_properties(LibsnoreQt5 PROPERTIES TYPE OPTIONAL
            URL "https://projects.kde.org/projects/playground/libs/snorenotify"
            DESCRIPTION "a cross-platform notification framework"
            PURPOSE     "Enable support for the snorenotify framework"
        )
        if(LibsnoreQt5_FOUND)
            find_package(LibsnoreSettingsQt5)
            set_package_properties(LibsnoreSettingsQt5 PROPERTIES TYPE REQUIRED
                URL "https://projects.kde.org/projects/playground/libs/snorenotify"
                DESCRIPTION "a cross-platform notification framework"
                PURPOSE     "Enable support for the snorenotify framework"
            )
        endif()
        

        if (WITH_WEBKIT)
            find_package(Qt5WebKit QUIET)
            set_package_properties(Qt5WebKit PROPERTIES TYPE RECOMMENDED
                URL "http://qt.digia.com"
                DESCRIPTION "a WebKit implementation for Qt"
                PURPOSE     "Needed for displaying previews for URLs in chat"
            )
            if (Qt5WebKit_FOUND)
                find_package(Qt5WebKitWidgets QUIET)
                set_package_properties(Qt5WebKitWidgets PROPERTIES TYPE RECOMMENDED
                    URL "http://qt.digia.com"
                    DESCRIPTION "widgets for Qt's WebKit implementation"
                    PURPOSE     "Needed for displaying previews for URLs in chat"
                )
            endif()
        endif()

        if (WITH_WEBKIT AND Qt5WebKitWidgets_FOUND)
            set(HAVE_WEBKIT true)
        endif()
        add_feature_info("WITH_WEBKIT, QtWebKit and QtWebKitWidgets modules" HAVE_WEBKIT "Support showing previews for URLs in chat")

        # KDE Frameworks
        ################

        if (WITH_KDE)
            set(ecm_find_type "REQUIRED")
        else()
            # Even with KDE integration disabled, we optionally use tier1 frameworks if we find them
            set(ecm_find_type "RECOMMENDED")
        endif()

        # extra-cmake-modules
        find_package(ECM NO_MODULE QUIET)
        set_package_properties(ECM PROPERTIES TYPE ${ecm_find_type}
            URL "https://projects.kde.org/projects/kdesupport/extra-cmake-modules"
            DESCRIPTION "extra modules for CMake, maintained by the KDE project"
            PURPOSE     "Required to find KDE Frameworks components"
        )

        if (ECM_FOUND)
            list(APPEND CMAKE_MODULE_PATH ${ECM_MODULE_PATH})
        endif()

        if (WITH_KDE)
            find_package(KF5 COMPONENTS ConfigWidgets CoreAddons Notifications NotifyConfig TextWidgets WidgetsAddons XmlGui QUIET)
            set_package_properties(KF5 PROPERTIES TYPE REQUIRED
                URL "http://www.kde.org"
                DESCRIPTION "KDE Frameworks"
                PURPOSE     "Required for integration into the Plasma desktop"
            )

        endif()

    endif(BUILD_GUI)

    if (BUILD_CORE)
        find_package(Qt5Script QUIET)
        set_package_properties(Qt5Script PROPERTIES TYPE REQUIRED
            DESCRIPTION "provides scripting support for Qt5"
        )
        find_package(Qt5Sql QUIET)
        set_package_properties(Qt5Sql PROPERTIES TYPE REQUIRED
            DESCRIPTION "the database support module for Qt5"
        )

        find_package(QCA2-QT5)
        set_package_properties(QCA2-QT5 PROPERTIES TYPE RECOMMENDED
            URL "https://projects.kde.org/projects/kdesupport/qca"
            DESCRIPTION "Qt Cryptographic Architecture"
            PURPOSE "Required for encryption support"
        )

    endif(BUILD_CORE)

=== icons/CMakeLists.txt ===
# Install icons
#
# We put the bundled oxygen icon theme in DATADIR rather than ICONDIR,
# in order to avoid conflicts. As we add this directory to XDG_DATA_DIRS at runtime,
# the bundled theme will be found by Qt only if there is no oxygen theme installed
# in system directories.
#
# The hicolor folder contains icons vital for the Quassel UI (such as in the channel and nick
# lists). It is installed into the system icon directory (in order to allow overriding) and
# additionally always embedded as a fallback resource.

if (WANT_MONO OR WANT_QTCLIENT)
    set(ICON_RCS ${CMAKE_CURRENT_SOURCE_DIR}/hicolor.qrc) # always embed those

    if (EMBED_DATA)
        if (WITH_OXYGEN)
            message(STATUS "Embedding bundled Oxygen icons")
            set(ICON_RCS ${ICON_RCS} ${CMAKE_CURRENT_SOURCE_DIR}/oxygen.qrc)
        endif()
    else()
        install(DIRECTORY hicolor DESTINATION ${CMAKE_INSTALL_ICONDIR})
        if (WITH_OXYGEN)
            message(STATUS "Installing bundled Oxygen icons")
            install(DIRECTORY oxygen DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel/icons)
        endif()
    endif()

    if (NOT WITH_OXYGEN)
        message(STATUS "Not installing bundled Oxygen icons")
    endif()

    set(CLIENT_RCS ${CLIENT_RCS} ${ICON_RCS} PARENT_SCOPE)
endif()

# Application icon

if (HAVE_KDE OR (UNIX AND NOT APPLE))
    install(FILES hicolor/48x48/apps/quassel.png DESTINATION ${CMAKE_INSTALL_ICONDIR}/hicolor/48x48/apps)
    if (CMAKE_INSTALL_PREFIX STREQUAL "/usr")
        install(FILES hicolor/48x48/apps/quassel.png DESTINATION /usr/share/pixmaps)
    endif()
endif()

=== pics/CMakeLists.txt ===
# pics/ contains non-themed icons and other graphical resources

if(WIN32)
  if(MINGW)
    find_program(WINDRES_EXECUTABLE NAMES windres)
    if(WINDRES_EXECUTABLE)
      exec_program(windres
              ARGS "-i ${CMAKE_CURRENT_SOURCE_DIR}/win32.rc"
                   "-o ${CMAKE_CURRENT_BINARY_DIR}/win32.o"
                   "--include-dir=${CMAKE_CURRENT_SOURCE_DIR}")
      set(COMMON_DEPS ${COMMON_DEPS} ${CMAKE_CURRENT_BINARY_DIR}/win32.o PARENT_SCOPE)
    endif(WINDRES_EXECUTABLE)
  else(MINGW)
    set(COMMON_DEPS ${COMMON_DEPS} ${CMAKE_CURRENT_SOURCE_DIR}/win32.rc PARENT_SCOPE)
  endif(MINGW)
endif(WIN32)

if(WANT_MONO OR WANT_QTCLIENT)
  if(EMBED_DATA)
    set(CLIENT_RCS ${CLIENT_RCS} ${CMAKE_CURRENT_SOURCE_DIR}/pics.qrc PARENT_SCOPE)
  else(EMBED_DATA)
    # We don't find them yet externally, so disable installation
    set(CLIENT_RCS ${CLIENT_RCS} ${CMAKE_CURRENT_SOURCE_DIR}/pics.qrc PARENT_SCOPE)
    # install(FILES qt-logo.png
    #               quassel-large.png
    #         DESTINATION ${DATA_INSTALL_DIR}/quassel/pics)
  endif(EMBED_DATA)
endif(WANT_MONO OR WANT_QTCLIENT)

=== po/CMakeLists.txt ===
# Generate and add translations
# The LINGUAS variable can be used to limit that set

if(QT_LCONVERT_EXECUTABLE)
  # get environment variable for translations
  set(LINGUAS "$ENV{LINGUAS}")
  string(REGEX REPLACE "[ \t]+" \; output "${LINGUAS}")
  # Find more languages
  # We support xx.po and xx_YY.po, and additionally translations for qt using qt_xx.po or qt_xx_YY.po
  file(GLOB avail_pofiles *.po)
  foreach(PO_FILE ${avail_pofiles})
    get_filename_component(basename ${PO_FILE} NAME_WE)
    # CMake can't use MATCH to get the second catch...
    string(REGEX REPLACE "(qt_)?([a-zA-Z]+)(_.+)?$" "\\2" lang ${basename})

    # test if we want this language
    set(flg 1)
    if(LINGUAS)
      string(REGEX MATCH "${lang}" flg ${LINGUAS})
    endif(LINGUAS)
    if(flg)
      generate_ts(QM ${basename})
      generate_qm(QM ${basename})
      list(APPEND qm_files ${QM})
      list(APPEND gen_linguas ${lang})
    endif(flg)
  endforeach(PO_FILE ${avail_pofiles})
  if(gen_linguas)
    list(REMOVE_DUPLICATES gen_linguas)
  endif(gen_linguas)
  message(STATUS "Including languages: ${gen_linguas}")
else(QT_LCONVERT_EXECUTABLE)
  message(STATUS "WARNING: lconvert not found, you won't have translations!")
endif(QT_LCONVERT_EXECUTABLE)

# For a static or win32 build, we need to include Qt translations if available
if(QT_TRANSLATIONS_DIR)
  if(STATIC OR WIN32)
    foreach(LANG ${gen_linguas})
      file(GLOB lang_files ${QT_TRANSLATIONS_DIR}/qt_${LANG}*.qm)
      foreach(absfile ${lang_files})
        get_filename_component(filename ${absfile} NAME)
        message(STATUS "Importing ${filename}")
        configure_file(${absfile} ${CMAKE_CURRENT_BINARY_DIR}/${filename} COPYONLY)
        list(APPEND qm_files ${CMAKE_CURRENT_BINARY_DIR}/${filename})
      endforeach(absfile ${lang_files})
    endforeach(LANG ${gen_linguas})
  endif(STATIC OR WIN32)
endif(QT_TRANSLATIONS_DIR)

# Write resource file
set(resfile ${CMAKE_CURRENT_BINARY_DIR}/i18n.qrc)
file(WRITE ${resfile} "<!DOCTYPE RCC><RCC version=\"1.0\">\n"
                      "<qresource prefix=\"/i18n\">\n")
foreach(file ${qm_files})
  get_filename_component(file ${file} NAME)
  file(APPEND ${resfile} "    <file>${file}</file>\n")
endforeach(file ${qm_files})
file(APPEND ${resfile} "</qresource>\n</RCC>\n")

#add_custom_command(OUTPUT ${resfile} DEPENDS ${qm_files})
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${qm_files};i18n.qrc")

if(EMBED_DATA)
  set(COMMON_RCS ${COMMON_RCS} ${resfile} PARENT_SCOPE)
else(EMBED_DATA)
  install(FILES ${qm_files} DESTINATION ${CMAKE_INSTALL_DATADIR}/quassel/translations)
endif(EMBED_DATA)

add_custom_target(po DEPENDS ${qm_files})

=== src/CMakeLists.txt ===
# Builds the three main targets

add_subdirectory(common)
include_directories(BEFORE common)
if(BUILD_CORE)
  add_subdirectory(core)
  include_directories(BEFORE core)
endif(BUILD_CORE)
if(BUILD_GUI)
  add_subdirectory(client)
  add_subdirectory(uisupport)
  add_subdirectory(qtui)
  include_directories(BEFORE client)
  include_directories(BEFORE uisupport)
  include_directories(BEFORE qtui)

  if(STATIC)
    link_directories(${QT_PLUGINS_DIR}/imageformats)
    set(CLIENT_LIBRARIES ${CLIENT_LIBRARIES} qjpeg qgif)
  endif(STATIC)
endif(BUILD_GUI)

include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR}) # for version.gen

# We need to initialize the appropriate resources, so let's give our main.cpp some hints
if (EMBED_DATA)
    add_definitions(-DEMBED_DATA)
endif()
if (WITH_OXYGEN)
    add_definitions(-DWITH_OXYGEN)
endif()

# For KAboutData
if (WITH_KF5)
    set(CLIENT_LIBRARIES ${CLIENT_LIBRARIES} KF5::CoreAddons)
endif()

# Needed for showing the cli option if appropriate
if (HAVE_SYSLOG)
    add_definitions(-DHAVE_SYSLOG)
endif()

if(WANT_CORE)
  add_executable(quasselcore common/main.cpp ${CORE_DEPS} ${COMMON_DEPS})
  qt_use_modules(quasselcore Core Network ${CORE_QT_MODULES})
  add_dependencies(quasselcore po)
  set_target_properties(quasselcore PROPERTIES
                                    COMPILE_FLAGS "-DBUILD_CORE"
                                    OUTPUT_NAME ../quasselcore)
  target_link_libraries(quasselcore mod_core mod_common ${COMMON_LIBRARIES} ${QUASSEL_SSL_LIBRARIES} ${QT_QTMAIN_LIBRARY})
  install(TARGETS quasselcore RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif(WANT_CORE)

if (KDE4_FOUND)
    include_directories(${KDE4_INCLUDES})
endif()

if(WANT_QTCLIENT)
  add_executable(quasselclient WIN32 common/main.cpp ${CLIENT_DEPS} ${COMMON_DEPS})
  qt_use_modules(quasselclient Core Gui Network ${CLIENT_QT_MODULES})
  add_dependencies(quasselclient po)
  set_target_properties(quasselclient PROPERTIES
                                      COMPILE_FLAGS "-DBUILD_QTUI"
                                      OUTPUT_NAME ../quasselclient)
  target_link_libraries(quasselclient mod_qtui mod_uisupport mod_client mod_common ${COMMON_LIBRARIES} ${CLIENT_LIBRARIES} ${QUASSEL_SSL_LIBRARIES} ${QT_QTMAIN_LIBRARY})
  install(TARGETS quasselclient RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif(WANT_QTCLIENT)

if(WANT_MONO)
  add_executable(quassel WIN32 common/main.cpp qtui/monoapplication.cpp ${CLIENT_DEPS} ${CORE_DEPS} ${COMMON_DEPS})
  qt_use_modules(quassel Core Gui Network ${CLIENT_QT_MODULES} ${CORE_QT_MODULES})
  add_dependencies(quassel po)
  set_target_properties(quassel PROPERTIES
                                COMPILE_FLAGS "-DBUILD_MONO"
                                OUTPUT_NAME ../quassel)
  target_link_libraries(quassel mod_qtui mod_uisupport mod_client mod_core mod_common ${COMMON_LIBRARIES} ${CLIENT_LIBRARIES} ${QUASSEL_SSL_LIBRARIES} ${QT_QTMAIN_LIBRARY})
  install(TARGETS quassel RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
endif(WANT_MONO)

# Build bundles for MacOSX
if(APPLE)
  add_custom_command(TARGET quasselclient POST_BUILD
                     COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makebundle.py
                             ${CMAKE_SOURCE_DIR} "Quassel Client" ../quasselclient)
  add_custom_command(TARGET quassel POST_BUILD
                     COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makebundle.py
                             ${CMAKE_SOURCE_DIR} "Quassel" ../quassel)
  if(DEPLOY)
    add_custom_command(TARGET quasselclient POST_BUILD
                       COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makePackage.sh Client ..)
    add_custom_command(TARGET quasselcore POST_BUILD
                       COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makePackage.sh Core ..)
    add_custom_command(TARGET quasselcore POST_BUILD
                       COMMAND ${CMAKE_SOURCE_DIR}/scripts/build/macosx_makePackage.sh Mono ..)
  endif(DEPLOY)
endif(APPLE)

=== src/client/CMakeLists.txt ===
# Builds the client module

# In Qt4, we still have some minor deps to QtGui: QItemSelectionModel, QSortFilterProxyModel
# Still in Qt5: QAbstractItemView in BufferModel

set(SOURCES
    abstractmessageprocessor.cpp
    backlogrequester.cpp
    buffermodel.cpp
    buffersettings.cpp
    bufferviewoverlay.cpp
    client.cpp
    clientaliasmanager.cpp
    clientauthhandler.cpp
    clientbacklogmanager.cpp
    clientbufferviewconfig.cpp
    clientbufferviewmanager.cpp
    clientidentity.cpp
    clientignorelistmanager.cpp
    clientirclisthelper.cpp
    clientsettings.cpp
    clienttransfer.cpp
    clienttransfermanager.cpp
    clientuserinputhandler.cpp
    coreaccount.cpp
    coreaccountmodel.cpp
    coreconnection.cpp
    execwrapper.cpp
    irclistmodel.cpp
    messagefilter.cpp
    messagemodel.cpp
    networkmodel.cpp
    selectionmodelsynchronizer.cpp
    treemodel.cpp

    # needed for automoc
    abstractui.h
    clientcoreinfo.h
)

if (USE_QT5)
    list(APPEND qt_modules Widgets)
endif()

qt_add_resources(SOURCES ${CLIENT_RCS})

add_library(mod_client STATIC ${SOURCES})
qt_use_modules(mod_client Network Core Gui ${qt_modules})

target_link_libraries(mod_client mod_common)

=== src/common/CMakeLists.txt ===
# Builds the common module

set(SOURCES
    aliasmanager.cpp
    authhandler.cpp
    backlogmanager.cpp
    basichandler.cpp
    bufferinfo.cpp
    buffersyncer.cpp
    bufferviewconfig.cpp
    bufferviewmanager.cpp
    compressor.cpp
    ctcpevent.cpp
    event.cpp
    eventmanager.cpp
    identity.cpp
    ignorelistmanager.cpp
    internalpeer.cpp
    ircchannel.cpp
    ircevent.cpp
    irclisthelper.cpp
    ircuser.cpp
    logger.cpp
    message.cpp
    messageevent.cpp
    network.cpp
    networkconfig.cpp
    networkevent.cpp
    peer.cpp
    peerfactory.cpp
    presetnetworks.cpp
    quassel.cpp
    remotepeer.cpp
    settings.cpp
    signalproxy.cpp
    syncableobject.cpp
    transfer.cpp
    transfermanager.cpp
    util.cpp

    protocols/datastream/datastreampeer.cpp
    protocols/legacy/legacypeer.cpp

    # needed for automoc
    coreinfo.h
)

if (USE_QT5)
    list(APPEND SOURCES qt5cliparser.cpp)
else()
    list(APPEND SOURCES cliparser.cpp)
endif()

if (QCA2_FOUND OR QCA2-QT5_FOUND)
    set(SOURCES ${SOURCES} keyevent.cpp)
endif()

if (ZLIB_FOUND)
    add_definitions(-DHAVE_ZLIB)
    include_directories(${ZLIB_INCLUDE_DIRS})
else()
    set(SOURCES ${SOURCES} ../../3rdparty/miniz/miniz.c)
endif()

if (USE_QT4)
    set(SOURCES ${SOURCES} ../../3rdparty/sha512/sha512.c)
endif()

if (HAVE_SYSLOG)
    add_definitions(-DHAVE_SYSLOG)
endif()

if (APPLE)
    set(SOURCES ${SOURCES} mac_utils.cpp)
endif(APPLE)

if (WIN32)
    set(SOURCES ${SOURCES} logbacktrace_win.cpp)
else()
    if (EXECINFO_FOUND)
        add_definitions(-DHAVE_EXECINFO)
        include_directories(${EXECINFO_INCLUDES})
    endif()
    set(SOURCES ${SOURCES} logbacktrace_unix.cpp)
endif()

qt_add_resources(SOURCES ${COMMON_RCS})

add_library(mod_common STATIC ${SOURCES})
qt_use_modules(mod_common Core Network)

if (APPLE)
    target_link_libraries(mod_common "-framework CoreServices" "-framework CoreFoundation")
endif(APPLE)

target_link_libraries(mod_common ${CMAKE_DL_LIBS} ${EXECINFO_LIBRARIES})

if(ZLIB_FOUND)
    target_link_libraries(mod_common ${ZLIB_LIBRARIES})
endif()

# This is needed so translations are generated before trying to build the qrc.
# Should probably find a nicer solution with proper dependencies between the involved files, though...
add_dependencies(mod_common po)

=== src/core/CMakeLists.txt ===
# Builds the core module

set(SOURCES
    abstractsqlstorage.cpp
    core.cpp
    corealiasmanager.cpp
    coreapplication.cpp
    coreauthhandler.cpp
    corebacklogmanager.cpp
    corebasichandler.cpp
    corebuffersyncer.cpp
    corebufferviewconfig.cpp
    corebufferviewmanager.cpp
    corecoreinfo.cpp
    coreidentity.cpp
    coreignorelistmanager.cpp
    coreircchannel.cpp
    coreirclisthelper.cpp
    coreircuser.cpp
    corenetwork.cpp
    corenetworkconfig.cpp
    coresession.cpp
    coresessioneventprocessor.cpp
    coresettings.cpp
    coretransfer.cpp
    coretransfermanager.cpp
    coreuserinputhandler.cpp
    coreusersettings.cpp
    ctcpparser.cpp
    eventstringifier.cpp
    ircparser.cpp
    netsplit.cpp
    oidentdconfiggenerator.cpp
    postgresqlstorage.cpp
    sessionthread.cpp
    sqlitestorage.cpp
    storage.cpp

    # needed for automoc
    coreeventmanager.h
)

set(LIBS )

if(HAVE_SSL)
  set(SOURCES ${SOURCES} sslserver.cpp)
  include_directories(${OPENSSL_INCLUDE_DIR})
endif(HAVE_SSL)

if (QCA2_FOUND)
    add_definitions(-DHAVE_QCA2)
    include_directories(${QCA2_INCLUDE_DIR})
    list(APPEND SOURCES cipher.cpp)
    list(APPEND LIBS ${QCA2_LIBRARIES})
endif()

if (QCA2-QT5_FOUND)
    add_definitions(-DHAVE_QCA2)
    include_directories(${QCA2-QT5_INCLUDE_DIR})
    list(APPEND SOURCES cipher.cpp)
    list(APPEND LIBS ${QCA2-QT5_LIBRARIES})
endif()

include_directories(${CMAKE_SOURCE_DIR}/src/common)

set(CORE_RCS ${CORE_RCS} ${CMAKE_CURRENT_SOURCE_DIR}/sql.qrc)
qt_add_resources(SOURCES ${CORE_RCS})

add_library(mod_core STATIC ${SOURCES})
qt_use_modules(mod_core Core Network Script Sql)

target_link_libraries(mod_core mod_common ${LIBS})

=== src/qtui/CMakeLists.txt ===
# Builds the qtui module

set(SOURCES
    aboutdlg.cpp
    awaylogfilter.cpp
    awaylogview.cpp
    bufferwidget.cpp
    channellistdlg.cpp
    chatitem.cpp
    chatline.cpp
    chatlinemodel.cpp
    chatlinemodelitem.cpp
    chatmonitorfilter.cpp
    chatmonitorview.cpp
    chatscene.cpp
    chatview.cpp
    chatviewsearchbar.cpp
    chatviewsearchcontroller.cpp
    chatviewsettings.cpp
    columnhandleitem.cpp
    coreconfigwizard.cpp
    coreconnectdlg.cpp
    coreconnectionstatuswidget.cpp
    coreinfodlg.cpp
    debugbufferviewoverlay.cpp
    debugconsole.cpp
    debuglogwidget.cpp
    debugmessagemodelfilter.cpp
    inputwidget.cpp
    ircconnectionwizard.cpp
    legacysystemtray.cpp
    mainpage.cpp
    mainwin.cpp
    markerlineitem.cpp
    msgprocessorstatuswidget.cpp
    nicklistwidget.cpp
    passwordchangedlg.cpp
    qtui.cpp
    qtuiapplication.cpp
    qtuimessageprocessor.cpp
    qtuisettings.cpp
    qtuistyle.cpp
    receivefiledlg.cpp
    settingsdlg.cpp
    settingspagedlg.cpp
    simplenetworkeditor.cpp
    systemtray.cpp
    systraynotificationbackend.cpp
    taskbarnotificationbackend.cpp
    titlesetter.cpp
    topicwidget.cpp
    verticaldock.cpp
    webpreviewitem.cpp
)

set(FORMS
    aboutdlg.ui
    bufferviewwidget.ui
    bufferwidget.ui
    channellistdlg.ui
    chatviewsearchbar.ui
    coreconfigwizardintropage.ui
    coreconfigwizardadminuserpage.ui
    coreconfigwizardstorageselectionpage.ui
    coreconfigwizardsyncpage.ui
    coreconnectauthdlg.ui
    coreconnectionstatuswidget.ui
    coreinfodlg.ui
    debugbufferviewoverlay.ui
    debugconsole.ui
    debuglogwidget.ui
    inputwidget.ui
    msgprocessorstatuswidget.ui
    nicklistwidget.ui
    passwordchangedlg.ui
    settingsdlg.ui
    settingspagedlg.ui
    simplenetworkeditor.ui
    receivefiledlg.ui
    topicwidget.ui
)

set(LIBS )
set(QT_MODULES )

if (WITH_KDE4)
    add_definitions(-DHAVE_KDE ${KDE4_DEFINITIONS})
    include_directories(${KDE4_INCLUDES})
    list(APPEND SOURCES knotificationbackend.cpp)
    list(APPEND LIBS ${KDE4_KDECORE_LIBS} ${KDE4_KDEUI_LIBRARY} ${KDE4_KNOTIFYCONFIG_LIBRARY})
endif()

if (WITH_KF5)
    list(APPEND SOURCES knotificationbackend.cpp)
    list(APPEND LIBS KF5::ConfigWidgets KF5::Notifications KF5::NotifyConfig KF5::WidgetsAddons KF5::XmlGui)
endif()

if (LibsnoreQt5_FOUND)
    add_definitions(-DHAVE_LIBSNORE)
    list(APPEND SOURCES snorenotificationbackend.cpp)
    list(APPEND FORMS   snorentificationconfigwidget.ui)
    list(APPEND LIBS    Snore::Libsnore Snore::LibsnoreSettings)
endif()

if (PHONON_FOUND OR Phonon4Qt5_FOUND)
    add_definitions(-DHAVE_PHONON)
    include_directories(${PHONON_INCLUDES})
    set(SOURCES ${SOURCES} phononnotificationbackend.cpp)
    set(FORMS ${FORMS}     phononnotificationconfigwidget.ui)
    list(APPEND LIBS ${PHONON_LIBS})  # PHONON_LIBRARIES only exists in config mode, it's not set by the legacy FindPhonon.cmake
endif()

if (QT_QTDBUS_FOUND OR Qt5DBus_FOUND)
    add_definitions(-DHAVE_DBUS)
    list(APPEND QT_MODULES DBus)
    if (dbusmenu-qt_FOUND OR dbusmenu-qt5_FOUND)
        add_definitions(-DHAVE_DBUSMENU)
        include_directories(${dbusmenu-qt_INCLUDE_DIRS} ${dbusmenu-qt5_INCLUDE_DIRS})
        if (dbusmenu-qt_FOUND)
            list(APPEND LIBS dbusmenu-qt)
        else()
            list(APPEND LIBS dbusmenu-qt5)
        endif()
    endif()

    list(APPEND SOURCES statusnotifieritem.cpp statusnotifieritemdbus.cpp dockmanagernotificationbackend.cpp)
    qt_add_dbus_interface(SOURCES ../../interfaces/org.kde.StatusNotifierWatcher.xml statusnotifierwatcher)
    qt_add_dbus_interface(SOURCES ../../interfaces/org.freedesktop.Notifications.xml notificationsclient)
    qt_add_dbus_adaptor  (SOURCES ../../interfaces/org.kde.StatusNotifierItem.xml statusnotifieritemdbus.h StatusNotifierItemDBus)
endif()

if (HAVE_WEBKIT)
    add_definitions(-DHAVE_WEBKIT)
    list(APPEND QT_MODULES WebKit)
    if (USE_QT5)
        list(APPEND QT_MODULES WebKitWidgets)
    endif()
endif()

if(HAVE_SSL)
  set(SOURCES ${SOURCES} sslinfodlg.cpp)
  set(FORMS ${FORMS} sslinfodlg.ui)
endif(HAVE_SSL)

if (INDICATEQT_FOUND)
    add_definitions(-DHAVE_INDICATEQT)
    include_directories(${INDICATEQT_INCLUDE_DIRS})
    list(APPEND SOURCES indicatornotificationbackend.cpp)
    list(APPEND FORMS   indicatornotificationconfigwidget.ui)
    list(APPEND LIBS ${INDICATEQT_LIBRARIES})
endif()

if (WITH_NOTIFICATION_CENTER)
    add_definitions(-DHAVE_NOTIFICATION_CENTER)
    list(APPEND SOURCES osxnotificationbackend.mm)
    list(APPEND LIBS "/System/Library/Frameworks/Foundation.framework")
endif()

foreach(FORM ${FORMS})
  set(FORMPATH ${FORMPATH} ui/${FORM})
endforeach(FORM ${FORMS})

# handle settingspages
include(settingspages/settingspages.cmake)
foreach(SP ${SETTINGSPAGES})
  set(SPSRC ${SPSRC} settingspages/${SP}settingspage.cpp)
  set(SPFRM ${SPFRM} settingspages/${SP}settingspage.ui)
endforeach(SP ${SETTINGSPAGES})
foreach(SRC ${SP_SOURCES})
  set(SPSRC ${SPSRC} settingspages/${SRC})
endforeach(SRC ${SP_SOURCES})
foreach(FRM ${SP_FORMS})
  set(SPFRM ${SPFRM} settingspages/${FRM})
endforeach(FRM ${SP_FORMS})

include_directories(${CMAKE_SOURCE_DIR}/src/common
                    ${CMAKE_SOURCE_DIR}/src/client
                    ${CMAKE_SOURCE_DIR}/src/qtui
                    ${CMAKE_SOURCE_DIR}/src/qtui/settingspages
                    ${CMAKE_SOURCE_DIR}/src/uisupport
)

qt_wrap_ui(UI ${FORMPATH} ${SPFRM})

if (USE_QT5)
    list(APPEND QT_MODULES Widgets)
endif()


add_library(mod_qtui STATIC ${SOURCES} ${SPSRC} ${UI})
qt_use_modules(mod_qtui Core Gui Network ${QT_MODULES})

target_link_libraries(mod_qtui mod_client mod_common mod_uisupport ${LIBS})

=== src/uisupport/CMakeLists.txt ===
# Builds the uisupport module

set(SOURCES
    aboutdata.cpp
    abstractbuffercontainer.cpp
    abstractitemview.cpp
    action.cpp
    actioncollection.cpp
    bufferhotlistfilter.cpp
    bufferview.cpp
    bufferviewfilter.cpp
    bufferviewoverlayfilter.cpp
    clearablelineedit.cpp
    clickable.cpp
    clickablelabel.cpp
    colorbutton.cpp
    contextmenuactionprovider.cpp
    flatproxymodel.cpp
    fontselector.cpp
    graphicalui.cpp
    multilineedit.cpp
    networkmodelcontroller.cpp
    nickview.cpp
    nickviewfilter.cpp
    qssparser.cpp
    resizingstackedwidget.cpp
    settingspage.cpp
    styledlabel.cpp
    tabcompleter.cpp
    toolbaractionprovider.cpp
    uisettings.cpp
    uistyle.cpp

    # needed for automoc
    abstractnotificationbackend.h
)

if (WITH_KDE4)
    include_directories(${KDE4_INCLUDES})
    add_definitions(-DHAVE_KDE ${KDE4_DEFINITIONS})
    set(SOURCES ${SOURCES} kcmdlinewrapper.cpp)
endif()

include_directories(${CMAKE_SOURCE_DIR}/src/common
                    ${CMAKE_SOURCE_DIR}/src/client
)

if (USE_QT5)
    list(APPEND qt_modules Widgets)
endif()

add_library(mod_uisupport STATIC ${SOURCES})
qt_use_modules(mod_uisupport Core Gui Network ${qt_modules})

target_link_libraries(mod_uisupport mod_client mod_common)

if (WITH_KDE4)
    target_link_libraries(mod_uisupport ${KDE4_KDECORE_LIBS} ${KDE4_KDEUI_LIBRARY})
endif()

if (WITH_KF5)
    target_link_libraries(mod_uisupport KF5::CoreAddons KF5::TextWidgets KF5::XmlGui)
endif()

=== debian/changelog ===
quassel (1:0.12.4-2+deb9u1) stretch-security; urgency=high

  * Backport upstream commit to implement a custom deserializer.
    Fixes possible remote code execution. (Closes: #896914)
  * Backport upstream commit to reject client logins before the core is
    configured. Fixes a DoS vulnerability. (Closes: #896915)
  * Backport upstream commit to fix OpenSSL detection with Qt 5.6 and GCC 5.

 -- Felix Geyer <fgeyer@debian.org>  Sat, 28 Apr 2018 11:54:39 +0200

quassel (1:0.12.4-2) unstable; urgency=medium

  * Fix FTBFS when building only architecture dependent packages.

 -- Felix Geyer <fgeyer@debian.org>  Tue, 26 Apr 2016 19:10:51 +0200

quassel (1:0.12.4-1) unstable; urgency=medium

  * New upstream release.
  * quassel-core: Add libqt5sql5-psql to Suggests since PostgreSQL is supported
    as an alternative backend. (Closes: #552374)
  * Pass service name to dh_systemd_*. (Closes: #811149)
  * Replace bundled inxi script with a symlink to the one provided by pkg:inxi.
    (Closes: #814278)

 -- Felix Geyer <fgeyer@debian.org>  Tue, 26 Apr 2016 18:16:53 +0200

quassel (1:0.12.3-1) unstable; urgency=medium

  * New upstream release.
  * Drop patches that have been applied upstream:
    - 02_set-required-libs-and-flags.patch
    - 04_fix_ftbfs_qt55.patch
    - CVE-2015-8547.patch

 -- Felix Geyer <fgeyer@debian.org>  Thu, 11 Feb 2016 21:38:13 +0100

quassel (1:0.12.2-3) unstable; urgency=high

  * Fix CVE-2015-8547: op command denial of service issue (Closes: #807801)
    - Add CVE-2015-8547.patch

 -- Felix Geyer <fgeyer@debian.org>  Mon, 14 Dec 2015 21:25:33 +0100

quassel (1:0.12.2-2) unstable; urgency=medium

  * Fix FTBFS with Qt 5.5. (Closes: #802868)
    - Add 04_fix_ftbfs_qt55.patch

 -- Felix Geyer <fgeyer@debian.org>  Thu, 29 Oct 2015 17:05:50 +0100

quassel (1:0.12.2-1) unstable; urgency=medium

  [ Felix Geyer ]
  * New upstream release. (Closes: #779726)
  * Remove patches that have been applied upstream:
    - CVE-2014-8483.patch
    - CVE-2015-2778.patch
    - CVE-2015-3427.patch
  * Set maintainer to Debian KDE Extras Team.
  * Add Vcs control fields pointing to the new git packaging repo.
    (Closes: #732605)
  * Drop explicit phonon depenencies, they are automatically added.
  * Build quassel against Qt5 + KF5 libs instead of a Qt4 and a KDE4 variant.
    (Closes: #784519)
    - Remove quassel-data-kde4.
    - Turn quassel-kde4 and quassel-client-kde4 into transitional packages.
  * Enable parallel building.
  * Pass --fail-missing to dh_install.
  * Create the SSL certificate as user quasselcore to avoid a symlink race
    condition. (Closes: #753737)
  * Stop hardcoding the path to deluser / delgroup in postrm.
  * Enable all hardening build flags.
  * Build with -Wl,--as-needed.
  * Fix detection of OpenSSL when building against Qt5.
    - Add 02_set-required-libs-and-flags.patch from openSUSE.
  * Work around missing icon theme fallback in KF5.
    - Add 03_force_icon_theme.patch
    - Add oxygen-icon-theme to quassel-data/Recommends.

  [ Scott Kitterman ]
  * Add systemd service file and associated changes for quasselcore.

 -- Felix Geyer <fgeyer@debian.org>  Thu, 10 Sep 2015 22:44:32 +0200

quassel (1:0.10.0-2.4) unstable; urgency=high

  * Non-maintainer upload.
  * Fix CVE-2015-3427: SQL injection vulnerability in PostgreSQL backend.
    (Closes: #783926)
    - Add debian/patches/CVE-2015-3427.patch, cherry-picked from upstream.
    - The original issue was CVE-2013-4422 which had an incomplete fix.

 -- Felix Geyer <fgeyer@debian.org>  Tue, 05 May 2015 16:48:57 +0200

=== debian/control ===
Source: quassel
Section: net
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Thomas Mueller <thomas.mueller@tmit.eu>,
           Felix Geyer <fgeyer@debian.org>,
           Scott Kitterman <scott@kitterman.com>
Build-Depends: debhelper (>= 9.20130504~),
               cmake,
               dh-systemd,
               libqca-qt5-2-dev,
               zlib1g-dev,
               qttools5-dev-tools,
               qttools5-dev,
               qtscript5-dev,
               libphonon4qt5-dev,
               libphonon4qt5experimental-dev,
               libdbusmenu-qt5-dev,
               libqt5webkit5-dev,
               extra-cmake-modules,
               libkf5textwidgets-dev,
               libkf5coreaddons-dev,
               libkf5xmlgui-dev,
               libkf5notifications-dev,
               libkf5notifyconfig-dev,
               libkf5widgetsaddons-dev,
               libssl-dev
Homepage: http://www.quassel-irc.org
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/pkg-kde/kde-extras/quassel.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/kde-extras/quassel.git/

Package: quassel-core
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, libqt5sql5-sqlite, lsb-base (>= 3.2-14), openssl
Suggests: libqt5sql5-psql
Description: distributed IRC client - core component
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides only the core component.

Package: quassel-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, quassel-data (= ${source:Version}), dbus-x11
Breaks: quassel-client-kde4 (<< 0.12.2)
Replaces: quassel-client-kde4 (<< 0.12.2)
Description: distributed IRC client - client component
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides only the client component.

Package: quassel
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libqt5sql5-sqlite, quassel-data (= ${source:Version}), dbus-x11
Breaks: quassel-kde4 (<< 0.12.2)
Replaces: quassel-kde4 (<< 0.12.2)
Description: distributed IRC client - monolithic core+client
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides the monolithic client. It contains both core and
 client and can be used like a traditional IRC client, without requiring an
 external core.

Package: quassel-data
Architecture: all
Depends: ${misc:Depends}
Recommends: oxygen-icon-theme
Suggests: inxi
Conflicts: quassel-data-kde4
Description: distributed IRC client - shared data
 Quassel is a modern, cross-platform, distributed IRC client, meaning that
 one or more clients can attach to and detach from the central core. It's
 much like the popular combination of screen and a text-based IRC client
 such as WeeChat or irssi, but graphical.
 .
 This package provides files used by the Quassel client packages.

Package: quassel-client-kde4
Section: oldlibs
Priority: extra
Architecture: all
Depends: ${misc:Depends}, quassel-client (>= 0.12.2)
Description: transitional package to quassel-client
 This is an empty package to transition to quassel-client, it can be safely
 removed.

Package: quassel-kde4
Section: oldlibs
Priority: extra
Architecture: all
Depends: ${misc:Depends}, quassel (>= 0.12.2)
Description: transitional package to quassel
 This is an empty package to transition to quassel, it can be safely removed.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed

%:
	dh $@ --parallel --with systemd

override_dh_auto_configure:
	dh_auto_configure -- -DEMBED_DATA=OFF -DUSE_QT5=ON -DWITH_KDE=ON

override_dh_install:
	dh_install --fail-missing
	# replace inxi with a symlink
ifneq (,$(filter quassel-data, $(shell dh_listpackages)))
	rm debian/quassel-data/usr/share/quassel/scripts/inxi
endif

override_dh_installinit:
	dh_installinit -r --error-handler=exit --name=quasselcore

override_dh_systemd_enable:
	dh_systemd_enable --name=quasselcore

override_dh_systemd_start:
	dh_systemd_start --name=quasselcore

=== debian/watch ===
version=3

http://quassel-irc.org/downloads \
  /pub/quassel-(.*)\.tar\.bz2

## quassel 0.12.4-3ubuntu1%2B9.0trisquel2

=== debian/changelog ===
quassel (1:0.12.4-3ubuntu1+9.0trisquel2) etiona; urgency=medium

  * Change default channel

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sat, 16 Nov 2019 00:01:18 +0000

quassel (1:0.12.4-3ubuntu1) bionic; urgency=low

  * Merge from Debian Sid. Remaining changes:
    - Dropping of (different) transitional packages since 16.04 LTS released.
    - Apparmor profile.
    - Ufw profile.
  * The default channel is now #lubuntu because Lubuntu Next seeds quassel by
    default.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Sun, 18 Feb 2018 23:30:49 -0600

quassel (1:0.12.4-3) unstable; urgency=medium

  * Depend on default-dbus-session-bus | dbus-session-bus instead of dbus-x11.
    (Closes: #836142)
  * Provide support for --listen option in the init script and systemd service.
    (Closes: #590645)
  * Fix the OpenSSL detection.
    - Add Fix_the_ssl_check_with_Qt_5.6_and_gcc_5.patch,
      cherry picked from upstream.
  * Switch to debhelper compat level 10.
  * quassel-core postinst: chmod/chown only after creating the files/dirs.
  * Remove transitional packages quassel-kde4 and quassel-client-kde4.

 -- Felix Geyer <fgeyer@debian.org>  Thu, 08 Feb 2018 18:31:06 +0100

quassel (1:0.12.4-2ubuntu3) bionic; urgency=medium

  * No change rebuild against libdbusmenu-qt5-2.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Tue, 30 Jan 2018 22:44:58 +0300

quassel (1:0.12.4-2ubuntu2) yakkety; urgency=medium

  * Fix SSL issues with Qt5.6 and GCC5.
    - Add fix_ssl_qt5.6_gcc5.patch (from upstream git master)

 -- Michael Marley <michael@michaelmarley.com>  Mon, 01 Aug 2016 07:49:05 -0400

quassel (1:0.12.4-2ubuntu1) yakkety; urgency=medium

  * Merge with Debian. (LP: #1589128) (LP: #1582802)
  * Dropped changes include: 
    - Specify 2048-bit RSA key (default anyway now).
    - Many indentation differences.
    - Sysvinit file differences, different name for systemd file, 
      upstart file (no longer needed).
    - More complicated debian/rules.
    - Less hardening in Ubuntu, +all in Debian.
    - Some maintainer script transition for very old versions.
    - Changelog entries (manual combining welcome).
    - Qt 4 build dependencies.
  * Remaining changes:
    - Kubuntu channel tweak.
    - Dropping of (different) transitional packages since 16.04 LTS released.
    - Apparmor profile.
    - Ufw profile.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Mon, 01 Aug 2016 09:12:45 +0300

## quassel 0.12.4-3ubuntu1.18.04.3%2B9.0trisquel2

=== debian/changelog ===
quassel (1:0.12.4-3ubuntu1.18.04.3+9.0trisquel2) etiona-security; urgency=medium

  * Change default channel

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Wed, 21 Oct 2020 14:09:24 +0000

quassel (1:0.12.4-3ubuntu1.18.04.3) bionic-security; urgency=medium

  * Merge security patches from Debian.
  * SECURITY UPDATE: Remote code execution.
    - d/p/Implement_custom_deserializer.patch: Implement custom
      deserializer to add sanity checks.
    - CVE-2018-1000178
  * SECURITY UPDATE: NULL pointer dereference.
    - d/p/Reject_clients_that_attempt_to_login_before_the_core_is_configured.patch:
      this patch prevents it from crashing the core.
    - CVE-2018-1000179

 -- Eduardo Barretto <eduardo.barretto@canonical.com>  Mon, 19 Oct 2020 16:53:16 -0300

quassel (1:0.12.4-3ubuntu1.18.04.2) bionic; urgency=medium

  * d/usr.bin.quasselcore:
    - Update apparmor profile to allow running in lxd (LP: #1814302)

 -- Dan Streetman <ddstreet@canonical.com>  Sun, 28 Jun 2020 11:01:19 -0400

quassel (1:0.12.4-3ubuntu1.18.04.1) bionic; urgency=medium

  * Cherry-pick fix introduced in Debian in revision 1:0.13.1-2 to fix
    apparmor profile (LP: #1863664)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 17 Feb 2020 19:06:19 +0100
